#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

int e;
vector<set<int> > vec;
set<int> st;

void dfs(int v, set<int> used = {}, int len = 0) {
    used.insert(v);
    st.insert(v);
    for (auto u: vec[v]) {
        if (used.count(u) == 0 && len + 1 <= e) {
            dfs(u, used, len + 1);
        }
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vec.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        vec[u].insert(v);
        vec[v].insert(u);
    }

    vector<pair<int, int> > v(k);
    for (int i = 0; i < k; i++) {
        int u, s;
        cin >> u >> s;
        u--;
        v[i] = {u, s};
    }
    for (auto el: v) {
        e = el.second;
        dfs(el.first);
    }

    cout << st.size() << "\n";
    for (auto el: st) {
        cout << el + 1 << " ";
    }
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

int main() {
    speed_up();
    int t = 1;
    while (t--) {
        solve();
    }
}
