#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
    string a, b;
    cin >> a >> b;
    int n = max((int) a.size(), (int) b.size());
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    vector<int> summ(n);
    for (int i = 0; i < n; i++) {
        if (i > b.size()) {
            summ[i] = a[i];
        } else if (i > a.size()) {
            summ[i] = b[i];
        } else {
            summ[i] = max((a[i] - '0'), (b[i] - '0'));
        }
    }
    reverse(summ.begin(), summ.end());
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());

    vector<string> res((int) b.size());
    for (int i = 0; i < b.size(); i++) {
        string s;
        for (int j = 0; j < a.size(); j++) {
            s += min(b[i], a[j]);
        }
        for (int j = 0; j < (int) b.size() - i - 1; j++) {
            s += "0";
        }
        res[i] = s;
    }

    reverse(res.begin(), res.end());
    for (int j = 1; j < res.size(); j++) {
        a = res[j - 1];
        b = res[j];
        string cur;
        reverse(a.begin(), a.end());
        reverse(b.begin(), b.end());
        int n = max((int) a.size(), (int) b.size());
        for (int i = 0; i < n; i++) {
            if (i > b.size()) {
                cur += a[i];
            } else if (i > a.size()) {
                cur += b[i];
            } else {
                cur += max(a[i], b[i]);
            }
        }
        reverse(cur.begin(), cur.end());
        res[j] = cur;
    }

    // answer
    for (auto el: summ) {
        cout << el;
    }
    cout << " ";

    cout << res[res.size() - 1] << "\n";
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

int main() {
    speed_up();
    int t = 1;
    while (t--) {
        solve();
    }
}
