#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

void solve() {
    int a, b;
    cin >> a >> b;
    if (a == b && a != 1) {
        cout << "no" << "\n";
        return;
    }

    if (a == 1 && b == 1) {
        cout << "R" << "\n";
        return;
    }

    int g = gcd(a, b);
    a /= g;
    b /= g;

    vector<pair<pair<int, int>, string> > left = {{{0, 1}, ""}, {{1, 1}, "R"}}, right = {{{1, 1}, "R"}, {{1, 0}, ""}};
    pair<int, int> check = {a, b};
    bool f = false;
    string res;
    if ((double) a / (double) b <= 1) {
        while (true) {
            int cur = 1;
            int cc = 0;
            while (cur < (int) left.size()) {
                pair<int, int> el = {
                    {left[cur - 1].first.first + left[cur].first.first},
                    left[cur - 1].first.second + left[cur].first.second
                };
                pair<pair<int, int>, string> e = {el, ""};
                if (cc == 1) {
                    e.second = left[cur - 1].second + "R";
                } else {
                    e.second = left[cur].second + "L";
                }
                left.insert(left.begin() + cur, e);
                if (el == check) {
                    f = true;
                    cout << e.second << "\n";
                    return;
                }
                cur += 2;
                cc = 1 - cc;
            }
        }
    }

    int cc = 0;
    while (true) {
        cc++;
        if (cc > 6) {
            break;
        }
        int cur = 1;
        while (cur < (int) right.size()) {
            int cc = 0;
            pair<int, int> el = {
                {right[cur - 1].first.first + right[cur].first.first},
                right[cur - 1].first.second + right[cur].first.second
            };
            pair<pair<int, int>, string> e = {{el}, ""};
            if (cc == 1 || (el.first == 2 && el.second == 1)) {
                e.second = right[cur - 1].second + "R";
            } else {
                e.second = right[cur].second + "L";
            }
            right.insert(right.begin() + cur, e);
            if (el == check) {
                cout << e.second << "\n";
                return;
            }
            cur += 2;
            cc = 1 - cc;
        }
    }
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

int main() {
    speed_up();
    int t = 1;
    while (t--) {
        solve();
    }
}
